/*
 * Skeleton of class to solve travelling salesman problem (TSP) with static & dynamic exemplary graphs
 */
 
import java.io.*;
import java.util.*;

public class TSP {
	...
	
	// Calculate static example with 3 nodes and 6 paths
	// Returns shortest path as permutation with sequence of node indices
	public Permutation shortestPathStatic() {
		...
	}

	// Calculate shortest path for arbitrary graphs (not suitable for very large graphs!)
	// Returns shortest path as permutation array with sequence of node indices
	public Permutation[] shortestPath() {
		...
	}
	
	// Calculate length for given path represented as permutation of node indices
	private int pathLength(Permutation path) {
		...
	}
	
	// Read graph from text file with number of nodes and distances in format
	// line 1:      n
	// line 2:      d_00 d_01 ... d_0n
	// line n+1: d_n0 d_n1 ... d_nn
	public void readGraph(String fileName) {
		...
	}

	public static void main(String[] args) {
		TSP tsp = new TSP();
		System.out.println("*** Static test ***");
		Permutation spath = tsp.shortestPathStatic();
		int length = tsp.pathLength(spath);
		System.out.println("-> Shortest path: " + spath + " with length " + length);
		System.out.println("*** Dynamic test ***");
		tsp.readGraph("graph.txt");
		spath = tsp.shortestPath();
		length = tsp.pathLength(spath);
		System.out.println("-> Shortest path: " + spath + " with length " + length);
	}
}
